unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses MsCTF;

{$R *.dfm}

function GetIMEList(slRet: TStrings; OnlyEnabled: Boolean = True): Boolean;
var
  pProfiles: PTfInputProcessorProfiles;
  IProfiles: ITfInputProcessorProfiles;
  LangId: Word;
  EnumProfiles: IEnumTfLanguageProfiles;
  LangProfile: TF_LANGUAGEPROFILE;
  FetchedItems: Cardinal;
  strProfile: WideString;
  nEnabled: Integer;
  hRet: HRESULT;
begin
  Result:= False;

  if not IsMSCTFAvailable() then
    Exit;

  hRet:= TF_CreateInputProcessorProfiles(@pProfiles);
  if not Succeeded(hRet) then
    Exit;
  
  IProfiles := ITfInputProcessorProfiles(pProfiles);
  LangId:= 0;
  IProfiles.GetCurrentLanguage(LangId);
  if LangId = Word(-1) then
    Exit;

  EnumProfiles:= nil;
  IProfiles.EnumLanguageProfiles(LangId, EnumProfiles);
  if EnumProfiles = nil then
    Exit;

  slRet.Clear;
  EnumProfiles.Next(1, LangProfile, FetchedItems);
  while FetchedItems > 0 do
  begin
    strProfile := '';
    hRet:= IProfiles.GetLanguageProfileDescription(LangProfile.clsid,
        LangProfile.langid, LangProfile.guidProfile, strProfile);
    if Succeeded(hRet) then
    begin
      if OnlyEnabled then
      begin
        nEnabled:= 0;
        hRet:= IProfiles.IsEnabledLanguageProfile(LangProfile.clsid,
            LangProfile.langid, LangProfile.guidProfile, nEnabled);

        if Succeeded(hRet) and (nEnabled = 1) then
          slRet.Add(strProfile);
      end else
      begin
        slRet.Add(strProfile);
      end;
    end;
    EnumProfiles.Next(1, langProfile, FetchedItems);
  end;
end;


procedure TForm1.Button2Click(Sender: TObject);
var
  sl: TStringList;
begin
  sl:= TStringList.Create;
  GetIMEList(sl);

  Memo1.Lines.AddStrings(sl);
end;



procedure TForm1.Button3Click(Sender: TObject);
var
  sl: TStringList;
begin
  sl:= TStringList.Create;
  GetIMEList(sl, False);
  Memo1.Lines.AddStrings(sl);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  pProfiles: PTfInputProcessorProfiles;
  IProfiles: ITfInputProcessorProfiles;
  LangId: Word;
  enumerator: IEnumTfLanguageProfiles;
  langProfile: TF_LANGUAGEPROFILE;
  FetchedItems: Cardinal;
  pbstrProfile: WideString;
  pfEnable: Integer;
  hRet: HRESULT;
begin
  Memo1.SetFocus;

  if not IsMSCTFAvailable() then
    Exit;


  hRet:= TF_CreateInputProcessorProfiles(@pProfiles);
  if hRet = S_OK then
  begin
    IProfiles := ITfInputProcessorProfiles(pProfiles);

    LangId:= 0;
    IProfiles.GetCurrentLanguage(LangId);

    Memo1.Lines.Add(IntToStr(LangId));
    if LangId > -1 then
    begin
      IProfiles.EnumLanguageProfiles(LangId, enumerator);
      if Assigned(enumerator) then
      begin
        enumerator.Next(1, langProfile, FetchedItems);
        while FetchedItems > 0 do
        begin
          // -1ʱΪǰ뷨
          pbstrProfile := '';

          Memo1.Lines.Add('clsid: ' +  GUIDToString(langProfile.clsid));

          if IProfiles.GetLanguageProfileDescription(langProfile.clsid, langProfile.langid, langProfile.guidProfile, pbstrProfile) = S_OK then
          begin
            Memo1.Lines.Add(pbstrProfile);
            if IProfiles.IsEnabledLanguageProfile(langProfile.clsid, langProfile.langid, langProfile.guidProfile, pfEnable) = S_OK then
            begin
              if pfEnable = 1 then
              begin                //ʾTSF뷨
                Memo1.Lines.Add(pbstrProfile);
                if pbstrProfile = ' ҷ' then
                begin
                  hRet:= IProfiles.ActivateLanguageProfile(langProfile.clsid, langProfile.langid, langProfile.guidProfile);
                  if hRet = S_OK then
                  begin
                    Memo1.Lines.Add('лɹ');
                  end;
                end;
              end;
            end;
          end;
          enumerator.Next(1, langProfile, FetchedItems);
        end;
      end;
    end;
  end;
end;

end.
